# include	"TransSkel.h"

# include	"ListEdit.h"
# include	"MakeWrite.h"


/*
 * Offsets of each field in the map and font lists.  There is one
 * extra value, which is actually the offset of the right edge of
 * the last field.  These offsets are relative to the text area.
 */


# define	mapFields	4		/* number of fields in mapping */


static short		mapOffsets[mapFields + 1] =
{
	0,
	100,
	217,
	257,
	313
};


static LineList	mapStruct =
{
	nil,						/* port - filled in later        */
	nil,						/* control - filled in later     */
	{ 150, 124, 246, 436 },		/* text display rect, t, l, b, r */
	0,							/* max lines (set by InitList)   */
	6,							/* max visible lines             */
	0,							/* top visible line              */
	16,							/* line height                   */
	0,							/* number of lines               */
	noLine,						/* current line                  */
	false,						/* no hiliting                   */
	mapFields,					/* number of fields/line         */
	mapOffsets,					/* field offsets                 */
	nil							/* line array (set by InitList)  */
};



WindowPtr	mapWind;

LListPtr	mapList = &mapStruct;
MapSpec		mapSpec[maxMappings];

Boolean		mapModified = false;

short		undoOp = noUndo;
short		undoVal;
short		undoPos;
short		undoFieldType;
MapSpec		undoMSpec;
Boolean		undoCPMarker;

Boolean		havePasteMSpec = false;	/* for setting Paste menu item */

Boolean		cpMarker = false;	/* whether cut/paste applies to marker */


/*
 * Paragraph style control
 *
 * Default is "every line a paragraph", ignore command-only lines
 */

ParaStyle	paraStyle;

Str255	paraMark;	/* paragraph marker string */
Str255	pageMark;	/* page break marker string */
Str255	periodStr;	/* sentence "periods" (terminators) */
Str255	quoteStr;	/* quotes to ignore after periods */

# ifdef	debug
Boolean	debugOut = false;	/* controls debugging output during format */
# endif


int
main (void)
{
	SkelInit ((SkelInitParamsPtr) nil);
	InitParaStyle ();
	SetupMenus ();
	MapSetup ();
	SkelEventLoop ();
	SkelCleanup ();
}
