# include	"TransSkel.h"
# include	"TransDisplay.h"

# include	"MakeWrite.h"


static WindowPtr	meterWind = nil;
static WindowPtr	helpWind = nil;
static short		errCount;
static Str255		errWindName;
static short		hPercent;

/* ---------------------------------------------------------------- */
/*					General Display Window Routines					*/
/* ---------------------------------------------------------------- */


static pascal void
DWindActivate (Boolean active)
{
WindowPtr	w;

	if (!active)	/* deactivated - was it closed? */
	{
		GetPort (&w);
		if (((WindowPeek) w)->visible == 0)
		{
			SkelRmveWind (w);	/* yes - remove it */
			if (w == helpWind)
				helpWind = nil;
		}
	}
	FixMenus ();
}


/*
 * Build a display window.  NewDWindow makes it the current output
 * window for display output.  The window comes up in front unless
 * the meter is present, in which case it comes up under the meter.
 */

void
DisplayWindow (StringPtr title, Boolean visible)
{
static short	i = 0;
WindowPtr	w;
Rect		r;
short		h, v;

	if (meterWind != nil && i < 1)
		i = 1;
	h = i * 23 + 5;
	v = h + 65;
	SetRect (&r, h, v, h + 350, v + 200);
	SetDWindowNotify (nil, DWindActivate);
	w = NewDWindow (&r, title, visible, (WindowPtr) -1L, true, 0L);
	if (visible)
		MakeFrontWind (w);
	if (++i == 4)
		i = 0;
}


/* ---------------------------------------------------------------- */
/*						Meter Window Routines						*/
/* ---------------------------------------------------------------- */


void
MeterPos (short h, short lineNo)
{
	SetPort (meterWind);
	MoveTo (h, (short) (lineNo * 16 + 14));
}


void
MeterString (StringPtr s)
{
	SetPort (meterWind);
	DrawString (s);
}


void
MeterInt (short i)
{
Str255	s;

	NumToString ((short) i, s);
	MeterString (s);
}


void
StartMeterPercentInfo (void)
{
PenState	p;

	MeterString ("\p     ");
	GetPenState (&p);
	hPercent = p.pnLoc.h;
}


void
SetMeterPercent (short i)
{
	MeterPos (hPercent, 1);
	MeterInt (i);
	MeterString ("\p%");
}


static pascal void
MeterClobber (void)
{
	DisposeWindow (meterWind);
	meterWind = nil;
}


void
MeterBegin (void)
{
Rect	r;

	SetRect (&r, 0, 0, 340, 36);
	if (SkelQuery (skelQHasColorQD))
	{
		meterWind = NewCWindow (nil, &r, "\p", false, dBoxProc,
							(WindowPtr) -1L, false, 0L);
	}
	else
	{
		meterWind = NewWindow (nil, &r, "\p", false, dBoxProc,
							(WindowPtr) -1L, false, 0L);
	}
	SkelWindow (meterWind, nil, nil, nil, nil, nil, MeterClobber, nil, false);
	TextFont (0);
	TextSize (0);
	TextMode (srcCopy);
	SkelPositionWindow (meterWind, skelPositionOnParentDevice,
									FixRatio (1, 2), FixRatio (1, 10));
	MakeFrontWind (meterWind);
}


void
MeterEnd (void)
{
	SkelRmveWind (meterWind);
}


/* ---------------------------------------------------------------- */
/*						Error Window Routines						*/
/* ---------------------------------------------------------------- */


/*
 * Initialize an error window.  This just clears the error count
 * and sets the name that will be given the window if an error
 * occurs.  The window doesn't actually appear unless the error
 * message routine is called.
 */

void
ErrWindInit (StringPtr fName)
{
	errCount = 0;
	CopyString (fName, errWindName);
}


void
ErrWindMsge (StringPtr thing, short value)
{
	if (errCount++ == 0)	/* first error */
	{
		DisplayWindow (errWindName, true);
	}
	DisplayString (thing);
	DisplayShort (value);
	DisplayLn ();
}


/* ---------------------------------------------------------------- */
/*						Help Window Routine							*/
/* ---------------------------------------------------------------- */


/*
 * Create help window, unless it already exists - in which case 
 * simply pull it to the front.
 */

void
HelpWindow (void)
{
Rect	r;
Handle	h;

	if (helpWind == nil)
	{
		SetRect (&r, 40, 50, 450, 280);
		SetDWindowNotify (nil, DWindActivate);
		helpWind = NewDWindow (&r, "\pInformation Window", false,
												(WindowPtr) -1L, true, 0L);
	
		h = GetResource ('TEXT', helpTextNum);	/* read help text */
		HLock (h);							/* lock it and write to window */
		DisplayText (*h, GetHandleSize (h));
		HUnlock (h);
		ReleaseResource (h);			/* done with it, so goodbye */
		SetDWindowPos (helpWind, 0);	/* scroll back to top */
		SetDWindow (nil);				/* no more output to this window */
	}
	MakeFrontWind (helpWind);
}
