# include	"ListEdit.h"
# include	"MWMapInfo.h"
# include	"MWMaca.h"


/*
 * # define debug	to enable debug output option
 * # undef  debug	to disable debug output option
 */

# undef	debug


# define	cr		'\r'
# define	enter	3


/*
 * Resource numbers
 */

typedef enum					/* alert/dialog numbers */
{
	aboutAlrtNum = 1000,	/* "About FaceLift..." alert */
	msgeAlrtNum,
	questAlrtNum,
	paraDlogNum,
	conflictAlrtNum,
	noPeriodAlrtNum,
	replaceAlrtNum
};


typedef enum
{
	fileMenuNum = 1000,
	editMenuNum,
	specialMenuNum,
	tempMenuNum			/* used for yanking font names from system */
};


typedef enum			/* STR resource numbers */
{
	periodStrNum = 1000,	/* default periods list */
	quoteStrNum				/* default quotes list */
};


typedef enum			/* STR# resource numbers */
{
	fontStrNum = 1000	/* standard font list */
};


# define	helpTextNum		1000	/* TEXT for help window */


typedef enum		/* Undo operations */
{
	noUndo,			/* = "last op can't be undone" */
	undoDelete,
	undoInsert,
	undoPaste,
	undoFieldChg,
	undoTyping,
	undoMarkerOp
};


typedef enum		/* field numbers - don't change */
{
	markField = 0,
	fontField,
	sizeField,
	styleField
};


# define	maxMappings	100

# define	extraMarks	2		/* number of special markers */

typedef enum					/* special-marker indices */
{
	paraMarkIdx = maxMappings,	/* paragraph marker */
	pageMarkIdx					/* page break marker */
};


/*
 * Paragraph style control
 */

typedef struct
{
	Boolean	pEachLine;		/* each line is a paragraph */
	Boolean	pBlankLine;		/* blank lines are paragraphs */
	Boolean	pSmartJoin;		/* line-joining smart or not */
} ParaStyle;


# define	mwCreator	'MKWR'	/* map file creator */
# define	mwType		'MMAP'	/* map file type */
# define	mapVersion	2		/* current map file structure version */

/*
 * Variable definitions
 */

extern WindowPtr	mapWind;

extern LListPtr	mapList;
extern MapSpec	mapSpec[];

extern Boolean	mapModified;

extern short		undoOp;
extern short		undoVal;
extern short		undoPos;
extern short		undoFieldType;
extern MapSpec	undoMSpec;
extern Boolean	undoCPMarker;

extern Boolean	havePasteMSpec;

extern Boolean	cpMarker;


extern ParaStyle	paraStyle;
extern Str255		paraMark;
extern Str255		pageMark;
extern Str255		periodStr;
extern Str255		quoteStr;

# ifdef	debug
extern Boolean	debugOut;
# endif

Boolean FindEmptyMark (void);
void InitMarkStates (void);
short CheckMarkers (char c);
void FindConflicts (void);

void ResourceFonts (Boolean ask);
void StrFonts (Boolean ask);

Boolean SetParaInfo (ParaInfo6 *p, short height, Byte status,
				long dataPos, short dataLen, short comFormats);
Boolean WritePrelude (short f);
Boolean WriteLineHeights (short f, short paraCount);
Boolean WriteArrayInfo (short f, long seek, long piPos, short piLen,
											long lhPos, short lhLen);
Boolean WritePostlude (short f, short paraCount, PIAHandle paraInfo);

void ClearMapName (void);
void SetMapName (StringPtr name);
Boolean OpenMap (void);
Boolean AddMap (void);
Boolean SaveMap (Boolean askForName);

Boolean StatMSpec (MapSpec *mSpec);
void SelectMapping (short lineNo);
Boolean InsertMapping (MapSpec *mSpec, short n);
void NewMapping (void);
void DupMapping (short n);
void PasteMapping (MapSpec *mSpec, short n);
void DeleteMapping (short n);
void ClobberMap (void);
void SortMap (void);
void SquishMap (void);

Boolean SetFontSpec (short fNum, StringPtr fName);
void ResetFontList (void);
void SyncFontSpecs (void);
short FontIndex (short fontNum);
void FontName (short fontIndex, StringPtr str);
short SizeIndex (short size);
void SetCPMarker (Boolean useMarker);
void BlankCPCtrls (void);
void MSpecToMark (MapSpec *m);
void MarkerUndoSetup (void);
Boolean EditMarker (short item);
void SetMapFieldValue (short fieldType, short value);
void SetSelectors (short lineNo);
void MapSetup (void);

void MapSetup (void);

void FixMenus (void);
void SetupMenus (void);

void CopyString (StringPtr src, StringPtr dst);
void AppendString (StringPtr src, StringPtr dst);
short CompareString (StringPtr s1, StringPtr s2);
Boolean InString (StringPtr s, char c);
Boolean	MouseClick (void);
void MakeFrontWind (WindowPtr w);
Boolean ExpandHandle (Handle h, Size delta);
Boolean DiscardChanges (void);
Boolean DestroyWarn (void);
void Message (StringPtr s1, StringPtr s2, StringPtr s3, StringPtr s4);
void Message1 (StringPtr s1);
void Message2 (StringPtr s1, StringPtr s2);
void Message3 (StringPtr s1, StringPtr s2, StringPtr s3);

void InitMSpec (MapSpec *mSpec);
void TermMSpec (MapSpec *mSpec);
void CopyMSpec (MapSpec *srcMSpec, MapSpec *dstMSpec);
void ClearMSpec (MapSpec *mSpec);
short CompareMark (StringHandle s1, StringHandle s2);
short CompareMSpec (MapSpec *m1, MapSpec *m2);
void MSpecToMStr (MapSpec *mSpec, MapStr *mStr);
void FontToStr (short font, StringPtr str);
void SizeToStr (short size, StringPtr str);
void StyleToStr (short style, StringPtr str);

void InitParaStyle (void);
void DoParaDialog (void);

void TextToWrite (void);

void DisplayWindow (StringPtr title, Boolean visible);
void MeterPos (short h, short lineNo);
void MeterString (StringPtr s);
void MeterInt (short i);
void StartMeterPercentInfo (void);
void SetMeterPercent (short i);
void MeterBegin (void);
void MeterEnd (void);
void ErrWindInit (StringPtr fName);
void ErrWindMsge (StringPtr thing, short value);
void HelpWindow (void);
